% This sample code demonstarates accessing the SUB-20 GPIO pins

NET.addAssembly('C:\Program Files\SUB-20\bin\sub20dnc.dll');

sub20 = Xdimax.Sub20();

% simulate do { ... } while(0) loop
for k=0:0
    
    % Open first available SUB-20 device
    if ~ sub20.Open(0)
        break;
    end
    
    % Create a bitmask for GPIO12
    bit_mask=int32(bitshift(1, 12));
    
    % Configure GPIO12 as an output
    if ~ sub20.GPIO_SetConfig(bit_mask, bit_mask)
        break;
    end
    
    % Set GPIO12 to logical '1'
    if ~ sub20.GPIO_Write(bit_mask, bit_mask)
        break;
    end

    % Set GPIO12 to logical '0'
    if ~ sub20.GPIO_Write(0, bit_mask)
        break;
    end
    
    % Read all input pins to the 'val' variable
    [success val] = sub20.GPIO_Read(0) ;
    if ~ success
        break;
    end
    
    bits = dec2hex(uint32(val));

end

err = sub20.GetLastError();

% Close SUB-20 device
sub20.Close()

if err > 0
    fprintf('Error %d\n', sub20.GetLastError() )
    error('Error!')
end

