disp 'SUB-20 SPI sample. Configures SPI and exchanges data with SPI slave(SS=2)'

TransferSize = 3;

NET.addAssembly('C:\Program Files\SUB-20\bin\sub20dnc.dll');
sub20 = Xdimax.Sub20();

% simulate do { ... } while(0) loop
for k=0:0
    
    % Open first available SUB-20 device
    if ~ sub20.Open(0)
        break;
    end
    
    % Set SPI configuration
    if ~ sub20.SPI_SetConfig(sub20.SpiEnable + sub20.SpiCpolRise + ...
            sub20.SpiSmplSetup + sub20.SpiMsbFirst + sub20.SpiClk_4MHz )
        break;
    end
    
    % Create .NET data array
    Data = NET.createArray('System.Byte', TransferSize);
    
    % Fill up the array with data bytes to be sent
    Data.Set(0, hex2dec('2a'));
    Data.Set(1, hex2dec('2b'));
    Data.Set(2, hex2dec('2c'));
    
    % Exchange data with SPI slave(SS=2). SS signal stays high
    if ~ sub20.SPI_Transfer(Data, 2, sub20.SpiSS_H)
        break;
    end
    
    % Copy read data to the Matlab array
    ReadData=zeros(1, TransferSize);
    for i=1:TransferSize
        ReadData(i)= Data.Get(i-1) ;
    end
    
end

err = sub20.GetLastError();

% Close SUB-20 device
sub20.Close()

if err > 0
    fprintf('Error %d\n', sub20.GetLastError() )
    error('Error!')
end

